window.addEventListener("load", function()
{
  const occupancyGrid = document.getElementsByClassName("occupancy-grid")[0]
  const gridSlots = occupancyGrid.getElementsByClassName("slot")
  
  const endpoint = `${window.location.href}/slots`
  updateSlots()

  function updateSlots()
  {
    setTimeout(updateSlots, 5000)
    fetch(endpoint).then(response => response.json()).then(setCheckboxes)
  }

  function setCheckboxes(data)
  {
    let maxParticipants = 0
    const username = document.getElementById("username")
    for(let i=0; i<gridSlots.length; i++)
    {
      const slot = document.getElementById(`grid_slot_${i}`)
      let participants = []
      for(let participant in data)
      {
        if(data[participant][i] === '1')
        {
          participants.push(participant)
        }
      }
      if(username && data[username.value]) 
      {
        if(data[username.value][i] === '1')
        {
          slot.classList.add("my-slot")
          document.getElementsByName(`slot_${i}`)[0].checked = true
        }
        else
        {
          slot.classList.remove("my-slot")
          document.getElementsByName(`slot_${i}`)[0].checked = false
        }
      }
      slot.style.setProperty("--color-index", participants.length)
      slot.title = `${slot.title.split('\n')[0]}\n${participants.join(", ")}`
      maxParticipants = Math.max(participants.length, maxParticipants)
    }
    occupancyGrid.style.setProperty("--color-count", maxParticipants)
    
    const updateButton = this.document.getElementById("update-button")
    if(updateButton)
      updateButton.style.display = "none"
  }

  onCheckedChanged = function(checkables) {
    const data = new URLSearchParams();
    for (const pair of new FormData(document.getElementById("update-form"))) {
        data.append(pair[0], pair[1]);
    }

    fetch(endpoint, {
        method: 'post',
        body: data,
    }).then(response => response.json()).then(setCheckboxes)
  }
})
